#ifndef _NETINFO_H_
#define _NETINFO_H_

#pragma comment(lib, "netapi32.lib")

#include <cstring>
#include <windows.h>
#include <tchar.h>
#include <lm.h>

namespace net {

class NetObject {
	public:
		CString name;
};

class NetServer : public NetObject {
	public:
		DWORD platform;
		DWORD versionMajor;
		DWORD versionMinor;
		DWORD type;
		CString comment;
};

class NetUser : public NetObject {
	public:
		DWORD id;
		CString fullName;
		CString comment;
		DWORD flags;
};

class NetObjectEnumerator {
	protected:
		DWORD error;
		CArray<NetObject *, NetObject *> resources;
		INT_PTR index;
	public:
		static CString GetErrorMessage(DWORD dwLastError);
		NetObjectEnumerator();
		virtual ~NetObjectEnumerator();
		DWORD GetError() const;
		INT_PTR GetSize() const;
		bool HasNext() const;
		NetObject * GetNext();
		void GoBegin();
		NetObject * GetAt(INT_PTR n) const;
};

class NetServerEnumerator : public NetObjectEnumerator {
	private:
		CString domain;
	public:
		NetServerEnumerator(const CString &_domain = _T(""));
		~NetServerEnumerator();
	private:
		DWORD doQuery();
};

class NetUserEnumerator : public NetObjectEnumerator {
	private:
		CString server;
	public:
		NetUserEnumerator(const CString &_server = _T(""));
		~NetUserEnumerator();
	private:
		DWORD doQuery();
		DWORD connectIPC();
		DWORD disconnectIPC();
};

}

#endif
